# copyright: Huynh Duong Phuong Vi
# www.sketchupforyou.com
module S4U
	module S4u_importdxf
		def self.set_status_process(start=1,text="",process_length=1 )
			if start==0
				@process=1
			else
				if @process<=process_length and @process>=1
					Sketchup.status_text= "Processing #{text} : #{@process} / #{process_length}"
					@process+=1
				else
					Sketchup.status_text= "Finishing #{text}....."
				end
			end
		end
		def self.readDXF(dxfFile,sectionlist=["BLOCKS","ENTITIES","OBJECTS","TABLES"])
			ents=Hash.new
            f=File.open(dxfFile)
			codes1 = readcodes(f)
			while codes1[1] != "EOF"
				if codes1[1] == "SECTION"
					codes1 = readcodes(f)
					section=codes1[1]
					a=Array.new
					ent=Hash.new
					if (codes1[0]==2) and (sectionlist.include? section)
						a.clear;ent.clear;flagstart=false;lastcode=nil
						codes = readcodes(f)
						while codes[1] != "ENDSEC"
							if (codes[0]==0) || (codes[0]==9)
								a.push ent.clone if flagstart
								ent.clear;flagstart=codes[1]
							end
							if (flagstart=="LWPOLYLINE")
								if ((lastcode==20)||(lastcode==41)) && ((codes[0]==10)||(codes[0]==91))
									if  ent[42]
										ent[42]=[ent[42]] if ent[42].class != Array
										ent[42]<< "0"
									else
										ent[42] = "0"
									end
								end
							end
							if flagstart
								lastcode=codes[0]
								if  ent[codes[0]]
									ent[codes[0]]=[ent[codes[0]]] if ent[codes[0]].class != Array
									ent[codes[0]].push codes[1]
								else
									ent[codes[0]] = codes[1]
								end
							end
							codes = readcodes(f)
						end
						if flagstart
							a.push ent
							ents[section]=a
						end
					end
				 end
				 codes1 = readcodes(f)
			end
			f.close
			return ents
			rescue => error
            p error,error.backtrace.join('\n')
		end
		def self.readcodes(f)
			codeStr=f.gets
			return [0,"EOF"] if !codeStr  || codeStr.strip=="EOF"
			valStr =f.gets
            valStr.encode!('UTF-8', invalid: :replace, undef: :replace, replace: '')
			return [0,"EOF"] if !valStr  || valStr.strip=="EOF"
			return [codeStr.strip.to_i, valStr.strip]
			rescue => error
            p error,error.backtrace.join('\n')
		end
		def self.getBlocks(blk)
			bls=[];b=[];flag=false
			bls.clear;b.clear
			blk.each_index{|i|
				if (blk[i][0]=="BLOCK") || (blk[i][0]=="TABLE")
					b.push blk[i]
					flag=true
				elsif (blk[i][0]=="ENDBLK") || (blk[i][0]=="ENDTAB")
					b.push blk[i]
					bls.push b.clone
					b.clear
					flag=false
				elsif flag
					b.push blk[i]
				end
			}
			return bls
			rescue => error
            p error,error.backtrace.join('\n')
		end
		def self.add_block(block)
			@import_result["Block"]=0 if !@import_result["Block"]
			@import_result["Block"]+=1
			return if !block.is_a?(Array)
			e=block.shift
			be=block.pop
			ents=block
			return if ents.empty?
			definitions=Sketchup.active_model.definitions
			return if !e[2]
			defn_name=@unique_name + '_' + e[2]
			defn=definitions.find{|d| d.name==defn_name}
			defn=Sketchup.active_model.definitions.add(defn_name) if !defn
			if defn
				i=0
				while i< ents.length
						ent=ents[i]
						polyline=[];polyline.clear
						if ent && (ent[0]=="POLYLINE")
							polyline.push ent
							polyline.concat(ents.select{|e1| ent[5]==e1[330]})
						end
						if polyline.length>3
							self.add_polyline(polyline,defn.entities)
							i+=(polyline.length-1)
						else
							self.add_entities(ent,defn.entities)
						end
					i+=1
				end
				vector=Geom::Vector3d.new( e.fetch(10,0).to_f,e.fetch(20,0).to_f,e.fetch(30,0).to_f)
				tvector=Geom::Transformation.translation vector.reverse
				defn.entities.transform_entities(tvector, defn.entities.to_a)
			end
			rescue => error
			p error
		end
		def self.add_entities(ent,entities)

			return if !ent
			return if !@layeron.include?(ent[8])
			return if ent[60] && (ent[60].to_i == 1)
			if ent[0]=="LINE"
				self.add_line ent,entities
				@import_result[ent[0]]=0 if !@import_result[ent[0]]
				@import_result[ent[0]]+=1
			elsif ent[0]=="ARC"
				self.add_arc ent,entities
				@import_result[ent[0]]=0 if !@import_result[ent[0]]
				@import_result[ent[0]]+=1
			elsif ent[0]== "CIRCLE"
				self.add_circle ent,entities
				@import_result[ent[0]]=0 if !@import_result[ent[0]]
				@import_result[ent[0]]+=1
			elsif ent[0]== "ELLIPSE"
				self.add_ellipse ent,entities
				@import_result[ent[0]]=0 if !@import_result[ent[0]]
				@import_result[ent[0]]+=1
			elsif ent[0]== "LWPOLYLINE"
				self.add_lwpolyline ent,entities
				@import_result[ent[0]]=0 if !@import_result[ent[0]]
				@import_result[ent[0]]+=1
			elsif ent[0]== "MLINE"
				self.add_mline ent,entities
				@import_result[ent[0]]=0 if !@import_result[ent[0]]
				@import_result[ent[0]]+=1
			elsif ent[0]== "INSERT"
				self.add_group ent,entities
				@import_result[ent[0]]=0 if !@import_result[ent[0]]
				@import_result[ent[0]]+=1
			elsif ent[0]== "SPLINE"
				self.add_spline ent,entities
				@import_result[ent[0]]=0 if !@import_result[ent[0]]
				@import_result[ent[0]]+=1
			elsif ent[0]== "3DFACE"
				self.add_3dface ent,entities
				@import_result[ent[0]]=0 if !@import_result[ent[0]]
				@import_result[ent[0]]+=1
			elsif ent[0]=="TEXT"
				self.add_text ent,entities
				@import_result[ent[0]]=0 if !@import_result[ent[0]]
				@import_result[ent[0]]+=1
			elsif ent[0]=="MTEXT"
				self.add_mtext ent,entities
				@import_result[ent[0]]=0 if !@import_result[ent[0]]
				@import_result[ent[0]]+=1
			else
				@import_result["Ignored"]=0 if !@import_result["Ignored"]
				@import_result["Ignored"]+=1
			end
		end
		def self.get_ocs(z_axis)
			  if (z_axis.x.abs < (1.0/64.0)) && (z_axis.y.abs < (1.0/64.0))
				x_axis = Y_AXIS*z_axis
			  else
				x_axis = Z_AXIS*z_axis
			  end
			  y_axis = z_axis*x_axis
			  return Geom::Transformation.axes(ORIGIN, x_axis, y_axis, z_axis)
			  rescue => error
			  p error
		end
		def self.add_group(e,entities)
			defn_name= @unique_name + '_' + e[2]
			definitions = Sketchup.active_model.definitions
			defn=definitions.find{|d| d.name==defn_name}
			defn=definitions.add defn_name if !defn
			point=Geom::Point3d.new(e[10].to_f,e[20].to_f,e.fetch(30,0).to_f)
			zaxis=Geom::Vector3d.new( e.fetch(210,0).to_f,e.fetch(220,0).to_f,e.fetch(230,1).to_f)
			t=self.get_ocs(zaxis)
			point.transform!(t)
			tpoint = Geom::Transformation.new point,Z_AXIS
			ts=Geom::Transformation.scaling ORIGIN,e.fetch(41,1).to_f,e.fetch(42,1).to_f,e.fetch(43,1).to_f
			tr=Geom::Transformation.rotation ORIGIN,Z_AXIS,e.fetch(50,0).to_f.degrees
			if defn && tpoint && t && tr && ts
				instance = entities.add_instance(defn,tpoint*t*tr*ts)
				(instance.layer=Sketchup.active_model.layers.add(e[8])) if instance
			end
			rescue => error
			p error
		end
		def self.add_text(e,entities)
			if @options[:text]>0
				ps=[e[10].to_f,e[20].to_f,e.fetch(30,0).to_f]
				if @options[:text]==1 || @options[:text]==3
					g=entities.add_group
                    e1=e[1]#.encode!('UTF-8', invalid: :replace, undef: :replace, replace: '')
					if g && (g.is_a?Sketchup::Group) && e1
						text=g.entities.add_3d_text(e1, e.fetch(72,0).to_i,
						'Arial',false, false, e.fetch(40,1).to_f, 0 , 0, true, 0)
                        e8=e[8]#.encode!('UTF-8', invalid: :replace, undef: :replace, replace: '')
						if  g && g.valid? && e8
							layer=Sketchup.active_model.layers.add e8
							g.layer=layer if text && layer
							vec=Geom::Point3d.new(ps)-ORIGIN
                            angle = e.fetch(50,0).to_f.degrees
                            r= Geom::Transformation.rotation(ORIGIN, Z_AXIS, angle)
							g.transform! Geom::Transformation.translation(vec)*r
						end
					end
				end
				if @options[:text]==2 || @options[:text]==3
					ps1=[e[10].to_f,e[20].to_f,e.fetch(1,0).to_f]
					cp=entities.add_cpoint Geom::Point3d.new(ps1)
				end
			end
			rescue => error
            p error,error.backtrace.join('\n')
		end
		def self.add_mtext(e,entities)
			ps=[e[10].to_f,e[20].to_f,e.fetch(30,0).to_f]
			if @options[:text]>0
				t=e[1]
				if e[3]
					if e[3].class == Array
					   t=e[3].join('')
					else
						t=e[3]
					end
					if t =~ /{.*;.*}/
						t=t.split('}').collect{|s| s.sub(/{.*;/,'')}.join('')
					end
					t3=t
					t=e[1]
					if t =~ /{.*;.*}/
						t=t.split('}').collect{|s| s.sub(/{.*;/,'')}.join('')
					end
					t=t3+ t
				else
					if t =~ /{.*;.*}/
						t=t.split('}').collect{|s| s.sub(/{.*;/,'')}.join('')
					end
				end
				t.gsub!("\\P","\n")
				if @options[:text]==1 || @options[:text]==3
					g=entities.add_group
					if g && (g.is_a?Sketchup::Group)
							textfix=0
						if t =~ /\\pxq.;/
							if t[0..5] =~ /\\pxqc;/
								align=1
							elsif t[0..5] =~ /\\pxqr;/
								align=2
							else
								align=0
							end
							t=t[6..-1]
							textfix=(2-(e.fetch(71,0).to_i/3))*0.5
							align_w=0.5*align
						else
							align=((e.fetch(71,0).to_i)%3-1)
							textfix=(2-(e.fetch(71,0).to_i/3))*0.5
							align_w= 0.5*align
						end
						text=g.entities.add_3d_text(t, align,
						"Arial",false, false, e.fetch(40,1).to_f, 0 , 0, true, 0)
						layer=Sketchup.active_model.layers.add e[8]
						g.layer=layer if text && layer
						vec=Geom::Point3d.new(ps)-ORIGIN
                        angle = e.fetch(50,0).to_f.degrees
                        x_axis= Geom::Point3d.new(e.fetch(11,1).to_f,e.fetch(21,0).to_f,e.fetch(31,0).to_f)-ORIGIN
                        ang=x_axis.angle_between(X_AXIS)
                        if ang!=0 && Z_AXIS.samedirection?(x_axis.cross(X_AXIS))
                            ang=-ang
                        end
                        h=textfix*g.bounds.height
                        w=align_w*g.bounds.width
                        vec1=ORIGIN-Geom::Point3d.new(w,h,0)
                        r= Geom::Transformation.rotation(ORIGIN, Z_AXIS, ang+angle)
                        g.transform! Geom::Transformation.translation(vec)*r*Geom::Transformation.translation(vec1)
					end
				end
				if @options[:text]==2 || @options[:text]==3
					ps1=[e[10].to_f,e[20].to_f,t.to_f]
					cp=entities.add_cpoint Geom::Point3d.new(ps1)
				end
			end
			rescue => error
            p error,error.backtrace.join('\n')
		end
		def self.add_line(e,entities)
			ps=[e[10].to_f,e[20].to_f,e.fetch(30,0).to_f]
			pe=[e[11].to_f,e[21].to_f,e.fetch(31,0).to_f]
			edge=entities.add_line ps,pe
			layer=Sketchup.active_model.layers.add e[8]
			edge.layer=layer if edge && layer
			rescue => error
            p error,error.backtrace.join('\n')
		end
		def self.add_3dface(e,entities)
			p1=[e[10].to_f,e[20].to_f,e.fetch(30,0).to_f]
			p2=[e[11].to_f,e[21].to_f,e.fetch(31,0).to_f]
			p3=[e[12].to_f,e[22].to_f,e.fetch(32,0).to_f]
			p4=[e.fetch(13,p3.x).to_f,e.fetch(23,p3.y).to_f,e.fetch(33,p3.z).to_f]
			edges=entities.add_edges p1,p2,p3,p4,p1
			layer=Sketchup.active_model.layers.add e[8]
			edges.each{|ed| ed.layer=layer if ed.class == Sketchup::Edge } if edges && edges.length>0 && layer
			rescue => error
			p error
		end
		def self.add_bulge(entities,p1,p2,bul,t)
			w=p1.distance p2
			h=w*bul.abs/ 2.0
			#r= w*w/ 8*h + h/ 2.0
			r= w*(1 / bul.abs + bul.abs)/ 4.0
			l=r-h
			point=Geom::Point3d.new(((p1.x+p2.x)/ 2.0),((p1.y+p2.y)/ 2.0),((p1.z+p2.z)/ 2.0))
			vec=p1.vector_to p2
			return if vec.length==0
			vec_normal= (bul>=0 ? (Z_AXIS.cross vec) : (vec.cross Z_AXIS))
			vec_normal.length=l
			point.transform!(Geom::Transformation.translation(vec_normal))
			ang=4.0*Math.atan(bul)
			vec1 =ang < 0 ? (point.transform(t).vector_to p2.transform(t)) : (point.transform(t).vector_to p1.transform(t))
			new_center = point.transform(t)
			seg= @options[:arc_segments].to_f==0 ? ((ang.abs)*@@segment_arc.to_f / Math::PI) : @options[:arc_segments].to_f
			arc = entities.add_arc(new_center, vec1, t.zaxis, r, 0 ,ang.abs, seg)
			if !arc
				v=vec1.clone
				v.length=r
				p=(new_center+v)
				p1=p
				trans=Geom::Transformation.rotation(new_center, t.zaxis,ang.abs)
				p2=p.transform trans
				line=entities.add_line p1,p2
				arc=[line]
			end
			return arc
			rescue => error
			p error
		end
		def self.add_lwpolyline(e,entities)
			pl=[]
			(0..e[90].to_i-1).each{|i|
				pl<< [e[10][i].to_f,e[20][i].to_f,e.fetch(38,0).to_f]
			}
			(pl<<pl[0]) if (e[70].to_i & 1)==1
			z_axis = Geom::Vector3d.new( e.fetch(210, 0).to_f, e.fetch(220, 0).to_f, e.fetch(230, 1).to_f )
			t=self.get_ocs(z_axis)
			edges=[]
			e[42]=[e[42]] if e[42].class!=Array
			(0..pl.length-2).each{|i|
				if e[42][i] && (e[42][i].to_f!=0)
					arc=self.add_bulge( entities,pl[i],pl[i+1],e[42][i].to_f,t)
					edges+=arc if arc
				else
					line=entities.add_line(pl[i].transform(t),pl[i+1].transform(t))
					edges<<line if line
				end
			}
			layer=Sketchup.active_model.layers.add e[8]
			if layer && edges && edges.length>0
				edges.each{|ed| ed.layer=layer if ed.is_a?(Sketchup::Edge)}
			end
			rescue => error
			p error
		end
		def self.add_mline(e,entities)
			style=@mlinestyle.find{|s| s[2]==e[2]}
			nl=e[73].to_i
			vertex=[];vector_seg=[];vector_miter=[];vertex_a=[[],[]];points=[[],[]]
			e41=e[41].clone
			vertex_a=Array.new(e[72].to_i){Array.new}
			(0..e[72].to_i-1).each{|i|
				(0..nl-1).each{|j|
					vertex_a[i].push e41.slice!(0,e[74][(i*nl+j)].to_i)
				}
			}
			points=Array.new(nl){Array.new}
			(0..e[72].to_i-1).each{|i|
				vertex[i]=Geom::Point3d.new(e[11][i].to_f,e[21][i].to_f,e[31][i].to_f)
				vector_seg[i]=Geom::Vector3d.new(e[12][i].to_f,e[22][i].to_f,e[32][i].to_f)
				vector_miter[i]=Geom::Vector3d.new(e[13][i].to_f,e[23][i].to_f,e[33][i].to_f)
				(0..nl-1).each{|j|
					vertex1=vertex_a[i][j]
					points[j].push [vertex[i].clone,1]
					if vertex1[0].to_f!=0
						v1=vector_miter[i].clone
						v1.length=vertex1[0].to_f
						t1=Geom::Transformation.translation v1
						points[j].last[0]=points[j].last[0].transform t1
					end
					pstart=points[j].last.clone[0]
					v2=vector_seg[i].clone
					if vertex1[1].to_f != 0
						v2.length=vertex1[1].to_f
						t2=Geom::Transformation.translation v2
						points[j].last[0]=points[j].last[0].transform t2
					end
					(2..(vertex1.length-1)).each{|jj|
						v2=vector_seg[i].clone
						v2.length=vertex1[jj].to_f
						t2=Geom::Transformation.translation v2
						points[j].push [(pstart.clone.transform t2),(jj%2)]
					}
				}
			}
			layer=Sketchup.active_model.layers.add e[8]
			if e[71].to_i==3
				(0..nl-1).each{|j|
					points[j] << points[j][0]
				}
			end
			(0..nl-1).each{|j|
				points1=points[j]
				(0..points1.length-2).each{|i|
					if points1[i][1]==1
						edge=entities.add_line(points1[i][0],points1[i+1][0])
						edge.layer=layer if layer && edge
					end
				}
			}
			cap=style[70].to_i
			if (cap & 16 == 16) and e[71].to_i!=3
				edge=entities.add_line(points[0][0][0],points[-1][0][0])
				edge.layer=layer if layer && edge
			end
			if cap & 64 == 64
			end
			if (cap & 256  == 256) and e[71].to_i!=3
				edge=entities.add_line(points[0][-1][0],points[-1][-1][0])
				edge.layer=layer if layer && edge
			end
			if cap & 1024 == 1024
				# p "arc cuoi"
			end
		end
		def self.add_arc(e,entities)
			point = Geom::Point3d.new(e[10].to_f, e[20].to_f, e.fetch(30,0).to_f)
			ang1 = e[50].to_f.degrees
			ang2 = e[51].to_f.degrees
			radius = e[40].to_f
			z_axis = Geom::Vector3d.new( e.fetch(210, 0).to_f, e.fetch(220, 0).to_f, e.fetch(230, 1).to_f )
			t=self.get_ocs(z_axis)
			new_center = point.transform(t)
			ang2+=(Math::PI*2) if ang1 > ang2
			if @options[:arc_segments] =~ /max/i
				seg=(ang2-ang1)*(@options[:arc_segments].to_f)/ Math::PI
			else
				seg= @options[:arc_segments].to_f==0 ? ((ang2-ang1)*@@segment_arc.to_f/ Math::PI) : @options[:arc_segments].to_f
			end
			arc = entities.add_arc(new_center, t.xaxis, t.zaxis.normalize , radius, ang1 ,ang2, seg)
			if !arc
				v=t.xaxis.clone
				v.length=radius
				p=(new_center+v)
				trans=Geom::Transformation.rotation(new_center, t.zaxis,(e[50].to_f.degrees))
				p1=p.transform trans
				trans=Geom::Transformation.rotation(new_center, t.zaxis,(e[51].to_f.degrees))
				p2=p.transform trans
				line=entities.add_line p1,p2
				arc=[line]
			end
			layer=Sketchup.active_model.layers.add e[8]
			arc.each{|c| c.layer=layer } if layer && arc
			rescue => error
			p error
		end
		def self.add_circle(e,entities)
				point = Geom::Point3d.new(e[10].to_f, e[20].to_f, e.fetch(30,0).to_f)
				radius    = e[40].to_f
				z_axis = Geom::Vector3d.new( e.fetch(210, 0).to_f, e.fetch(220, 0).to_f, e.fetch(230, 1).to_f )
				t=self.get_ocs(z_axis)
				circle = entities.add_circle(point.transform(t),z_axis, radius, @options[:circle_segments])
				layer=Sketchup.active_model.layers.add e[8]
				circle.each{|c| c.layer=layer } if layer && circle
				rescue => error
				p error
		end
		def self.add_ellipse(e,entities)
				point = Geom::Point3d.new(e[10].to_f, e[20].to_f, e.fetch(30,0).to_f)
				ang1 = e[41].to_f
				ang2 = e[42].to_f
				a = Geom::Point3d.new(e[11].to_f, e[21].to_f, e.fetch(31,0).to_f)
				ratio = e[40].to_f
				w = a.distance(ORIGIN)
				h = w * ratio
				ang2+=(Math::PI*2) if ang1 > ang2
				seg= (@options[:ellipse_segments].to_f==0) ? ((ang2-ang1)*@@segment_arc.to_f / Math::PI) : @options[:ellipse_segments].to_f
				s = (ang2 - ang1)/ seg
				pts = []
				pt = []
				x_axis = ORIGIN.vector_to a
				z_axis = Geom::Vector3d.new( e.fetch(210, 0).to_f, e.fetch(220, 0).to_f, e.fetch(230, 1).to_f )
				trans = Geom::Transformation.new(x_axis,(z_axis.cross x_axis),z_axis,point)
				pos=ang1
				(ang1..ang2).step(s) { |ang|
					pt.clear
					pt.x = (w * Math.cos(ang))
					pt.y = (h * Math.sin(ang))
					pt.z = 0
					pos=ang
					pts << (pt.clone.transform trans)
				}
				if ang2>pos
					pt.clear
					pt.x = (w * Math.cos(ang2))
					pt.y = (h * Math.sin(ang2))
					pt.z = 0
					pts << (pt.clone.transform trans)
				end
				edges = entities.add_curve(pts)
				layer=Sketchup.active_model.layers.add e[8]
				edges.each{|c| c.layer=layer } if layer
				rescue => error
				p error
		end
		#http://mathworld.wolfram.com/B-Spline.html
		def self.rational_basis(n,u,d,knot)
			basis=[]
			(0..n).each{|i|
				#basis[i] = (((knot[i] <= u) && (u < knot[i+1])) && (knot[i] < knot[i+1]))? 1.0 : 0.0
				basis[i] = ((knot[i] <= u) && (u < knot[i+1]))? 1.0 : 0.0
			}
			(1..d).each{|j|
				(0..n).each{|i|
					basis[i] = (((knot[i+j] - knot[i]) == 0) ? 0.0 : ((u - knot[i]) * basis[i]/(knot[i+j] - knot[i]))) +
							   (((knot[i+j+1] - knot[i+1]) == 0) ? 0.0 : ((knot[i+j+1] - u)* basis[i+1]/(knot[i+j+1] - knot[i+1])))
				}
			}
			return basis
		end
		def self.nurbs(pts,segments,d,knot)
			ps=[]
			n=pts.length-1
			s=(knot[-1]-knot[0]).to_f/ segments
			pop=0
			knot[0].step(knot[-1],s){|t|
				basis=self.rational_basis(n,t,d,knot)
				point= Geom::Point3d.new(0,0,0)
				pop=t
				(0..n).each{|i|
					point.x += (pts[i].x*basis[i])
					point.y += (pts[i].y*basis[i])
					point.z += (pts[i].z*basis[i])
				}
				ps.push point #if (point != [0,0,0] ) || (pts[0]==[0,0,0])
			}
			ps[0]=pts[0]
			ps[-1]=pts[-1]
			return ps
		end
		def self.add_spline(e,entities)
			points=[]
			knot=e[40].collect{|i| i.to_f}
			(0..e[10].length-1).each{|i|
				points[i]= Geom::Point3d.new(e[10][i].to_f,e[20][i].to_f,e[30].fetch(i,0).to_f)
			}
			curver=self.nurbs(points,@options[:spline_segments].to_f,e[71].to_f,knot)
			edges = entities.add_curve( curver )
			layer=Sketchup.active_model.layers.add e[8]
			edges.each{|c| c.layer=layer } if layer && edges && edges.length>0
			return edges
			rescue => error
			p error.backtrace.join('\n')
		end
		def self.add_polyline(poly,entities)
			vertex=[]
			pointsfit=[]
			(1..(poly.length-2)).each{|i|
				if  poly[i][0] && (poly[i][0]=="VERTEX")
					v=Geom::Point3d.new(poly[i][10].to_f,poly[i][20].to_f,poly[i][30].to_f)
					vertex<< v
					(pointsfit<< v) if (poly[i].fetch(70,0).to_i & 8)==8
				end
			}
			if (poly[0][70].to_i) & 1 == 1
				vertex<< vertex[0]
				pointsfit<< pointsfit[0]
			end
			if poly[0][100] && poly[0][100].include?("AcDb2dPolyline") # OCS
				z_axis = Geom::Vector3d.new( poly[0].fetch(210, 0).to_f, poly[0].fetch(220, 0).to_f, poly[0].fetch(230, 1).to_f )
				t=self.get_ocs(z_axis)
				vertex.each{|v| v.transform!(t)}
			end
			if poly[0].fetch(75,0).to_i == 0
				edges=entities.add_edges vertex
			elsif (poly[0].fetch(75,0).to_i==6 or poly[0].fetch(75,0).to_i==5 ) and pointsfit.length>1
				edges = entities.add_curve pointsfit
			end
			layer = Sketchup.active_model.layers.add poly[0][8]
			edges.each{|c| c.layer = layer } if layer && edges && edges.length>0
			return edges
			rescue => error
                p error,error.backtrace.join('\n')
		end
		def self.importDXF(file)
			@@segment_arc=60
			return if !(Sketchup.is_pro?)

			@options ={:arc_segments=>0,:circle_segments=>96,:ellipse_segments=>0,:spline_segments=>100,:preserve_origin=>1,:group=>0} if !@options
			units=["Inches","Feet","mm","cm","m"]
			@options[:import_units] = units[Sketchup.active_model.options["UnitsOptions"]["LengthUnit"]] if !@options[:import_units]
			@unique_name=Time.now.to_i.to_s
			@layeron=[]
			@group_layer=[]
			@mlinestyle=[]
			entities=Sketchup.active_model.active_entities
			dxfgroup=entities.add_group
			blks= readDXF file
			(@mlinestyle= blks["OBJECTS"].select{|m| m[0]=="MLINESTYLE"}) if blks["OBJECTS"]
			bls=getBlocks blks["BLOCKS"] if blks["BLOCKS"]
			if bls
				blks["TABLES"].each{|m| @layeron << m[2] if m[0]=="LAYER" && m[62].to_f>0} if blks["TABLES"]
				self.set_status_process(0,"Add blocks",bls.length )
				bls.each_index{|i|
					self.set_status_process(1,"Add blocks",bls.length )
					if bls[i].length>2
						self.add_block(bls[i])
					end
				}
				self.set_status_process(1,"Add blocks",bls.length )
			end
			i=0
			self.set_status_process(0,"Add entities",blks["ENTITIES"].length )
			while i< blks["ENTITIES"].length
				self.set_status_process(1,"Add entities",blks["ENTITIES"].length )
				polyline=[];polyline.clear
				e=blks["ENTITIES"][i]
				break if e[0] == "VIEWPORT"
				if @options[:group]==0
                    name=(e[8] ? e[8] : '')
					definitions=Sketchup.active_model.definitions
					defn_name=@unique_name + '_' + name
					defn=definitions.find{|d| d.name==defn_name}
					if !defn
						defn=Sketchup.active_model.definitions.add(defn_name)
						@group_layer << [defn,name]
					end
				end
				if e[0]=="POLYLINE"
					polyline=[e]
					polyline.concat(blks["ENTITIES"].select{|e1| e[5]==e1[330]})
				end
				if polyline.length>3
					@import_result["POLYLINE"]=0 if !@import_result["POLYLINE"]
					@import_result["POLYLINE"]+=1
					if @options[:group]==1
						self.add_polyline(polyline,dxfgroup.entities)
					else
						self.add_polyline(polyline,defn.entities)
					end
					i+=(polyline.length-1)
				else
					if @options[:group]==1 || (e[0] && (e[0] == "INSERT"))
						self.add_entities(e,dxfgroup.entities)
					else
						self.add_entities(e,defn.entities)
					end
				end
				i+=1
			end
			self.set_status_process(1,"Add entities",blks["ENTITIES"].length )
			s=("1." + @options[:import_units]).to_f
			unit={"Inches"=>1.inch,"Feet"=>1.feet,"mm"=>1.mm,"cm"=>1.cm,"m"=>1.m}
			s=unit.fetch(@options[:import_units],1)
            #if dxfgroup && dxfgroup.valid?
                @group_layer.uniq.each{|g|
                    ins=dxfgroup.entities.add_instance(g[0],IDENTITY)
                    if ins && g[1]
                        layer=Sketchup.active_model.layers.add g[1]
                        ins.layer=layer if layer
                    end
                }
                dxfgroup.transformation =Geom::Transformation.scaling(s,s,s)
                if @options[:preserve_origin]==0
                    new_group=dxfgroup
                else
                    new_group=entities.add_group dxfgroup
                    new_group.transformation=Geom::Transformation.new(ORIGIN)
                    dxfgroup.explode
                end
                new_group.name=File.basename file,".dxf"
                sel=Sketchup.active_model.selection
                sel.clear
                sel.add new_group
                Sketchup.send_action "viewZoomToSelection:"
                return new_group
            #end
			rescue => error
                p error,error.backtrace.join('\n')
		end
		def self.get_segments_number()
			@options ={:arc_segments=>0,:circle_segments=>96,:ellipse_segments=>0,:spline_segments=>100,:preserve_origin=>1,:group=>0,:text=>0} if !@options
			units=["Inches","Feet","mm","cm","m"]
			unit= @options[:import_units] ? @options[:import_units] : units[Sketchup.active_model.options["UnitsOptions"]["LengthUnit"]]
			prompts = [Strings.GetString("DXF's unit?"),Strings.GetString("Arc segments?(100max)"),
			Strings.GetString("Circle segments?"),Strings.GetString("Ellipse segments?"),
			Strings.GetString("Spline segments?"),Strings.GetString("Preserve origin?"),
			Strings.GetString("Group Layer?"),Strings.GetString("Import Text?")]
			str_arc= @options[:arc_segments]==0 ? Strings.GetString("Auto") : @options[:arc_segments].to_s
			str_ellipse=@options[:ellipse_segments]==0 ? Strings.GetString("Auto") : @options[:ellipse_segments].to_s
			defaults = [unit,str_arc,@options[:circle_segments].to_s,
				str_ellipse,@options[:spline_segments].to_s,
			['Yes','No'][@options[:preserve_origin]],['Yes','No'][@options[:group]],
			['No',Strings.GetString("Text"),Strings.GetString("CPoint"),Strings.GetString("Text+CPoint"),][@options[:text]]]
			list = [units.join('|'),"","","","","Yes|No","Yes|No","No|Text|CPoint|Text+CPoint"]
			input = UI.inputbox(prompts, defaults, list, Strings.GetString("S4u ImportDXF Options"))
			if input
				@options[:import_units]=input[0]
				@options[:arc_segments]=input[1]#.to_f if input[1].to_f >=0
				@options[:circle_segments]=input[2].to_f if input[2].to_f > 1
				@options[:ellipse_segments]=input[3].to_f if input[3].to_f >=0
				@options[:spline_segments]=input[4].to_f if input[4].to_f > 1
				@options[:preserve_origin]= input[5]=='Yes' ? 0 : 1
				@options[:group]= (input[6]=='Yes') ? 0 : 1
				@options[:text]= (input[7]=='No') ? 0 : ((input[7]==Strings.GetString("Text"))? 1 :
				((input[7]==Strings.GetString("CPoint"))? 2 : 3))
				return true
			else
				return false
			end
		end
		def self.import(filename)
			if !(Sketchup.is_pro?)
				UI.messagebox Strings.GetString("This extension:S4u ImportDXF is only for Sketchup Pro")
				return
			end

			model=Sketchup.active_model
			model.start_operation(TOOL,true,false,false)
			@import_result={}
			self.importDXF filename
			@import_result["Layer"]=@layeron.length if @layeron
			text=Strings.GetString("AutoCAD Entities Imported:")
			endtext=Strings.GetString("AutoCAD Entities Ignored:")
			@import_result.each{|key,value|
				text+=  "\n         " +  "%-#{20-key.to_s.length}s%8d" % [ key.capitalize.to_s, value.to_s ]
				(endtext+= "\n         " +  "%-#{20-key.to_s.length}s%8d" % [ key.capitalize.to_s, value.to_s ]) if key.to_s=="Ignored"
			}
			text+= "\n" + endtext
			UI.messagebox(text,MB_MULTILINE)
			model.commit_operation
			rescue =>error
			p error
			p error.backtrace.join('\n')
			model.abort_operation
		end
		def self.main()
			if self.get_segments_number
				filename = UI.openpanel(Strings.GetString("Select DXF File"),"", "DXF|*.dxf|")
				self.import( filename) if filename
			end
		end
		class ImportDXF < Sketchup::Importer
			def description
				return "s4u_ImportDXF (*.dxf)"
			end
			def file_extension
				return "dxf"
			end
			def id
				return "com.sketchup.importers.s4u_importdxf"
			end
			def supports_options?
				return true
			end
			def do_options
				S4U::S4u_importdxf.get_segments_number
			end
			def load_file(file_path, status)
				if file_path
					S4U::S4u_importdxf.import file_path
					return 0
				end
			end
		end
		Sketchup.register_importer(ImportDXF.new)
	end
end